<?php 
/**
 * Plugin for Pluxml
 * @author	DPFPIC
 * Site : http://monblog.dpfpic.com/
 * Licence GNU_GPL
 * Le dévéloppement à été commencé par Gari (plnStatistiques)
 * et a été repris par Jormun (SimpleStat).
 **/
if(!defined('PLX_ROOT')) exit;
//error_reporting(E_ALL);

// update de la liste des spamref
if (!empty($_POST["spamref"])){

  $data = json_decode(file_get_contents("https://didcode.com/srb-blacklist-delta.php?version=2.22"),true);

  $spamref = explode("\n",  str_replace(array("\r\n", "\r"),"\n",$plxPlugin->getParam('SpamRef')));
  foreach($data as $k=>$v){
    $k = preg_replace('#[^A-Za-z0-9._-]+#', '', $k); //protection antihack au cas ou didcode tente une saloperie
    if (!in_array($k,$spamref)) $spamref[] = $k;
  }
  $plxPlugin->setParam('SpamRef', implode("\n",$spamref),  'cdata');
  $plxPlugin->saveParams();
	header('Location: parametres_plugin.php?p=plxSimpleStat');
	exit;
}

# Si on a des arguments POST, c'est que l'utilisateur a demandé à enregistrer les nouveaux paramètres.
# On enregistre donc.
if(!empty($_POST)) {
	$plxPlugin->setParam('RegexRobot',  $_POST['RegexRobot'],  'cdata');
	$plxPlugin->setParam('RegexSpamRef',  $_POST['RegexSpamRef'],  'cdata');
	$plxPlugin->setParam('BlacklistIP',  str_replace(array(" ","\r\n\r\n", "\n\n", "\r\r"),array('',"\r\n","\n","\r"),$_POST['BlacklistIP']),  'cdata');
	$plxPlugin->setParam('SpamRef',  str_replace(array(" ","\r\n\r\n", "\n\n", "\r\r"),array('',"\r\n","\n","\r"),$_POST['SpamRef']),  'cdata');
	$plxPlugin->setParam('DroitAcces',  (int) $_POST['DroitAcces'],  'numeric');
	$plxPlugin->setParam('autoBlacklistLevel',  (int) $_POST['autoBlacklistLevel'],  'numeric');
	$plxPlugin->setParam('ActAuto', $_POST['ActAuto'],  'numeric');
	$plxPlugin->setParam('ActAutoTime', $_POST['ActAutoTime'],  'numeric');
	
	$plxPlugin->saveParams();
	header('Location: parametres_plugin.php?p=plxSimpleStat');
	exit;
}



# On prépare la liste des profils utilisateurs possibles
$aDroitAcces = array( PROFIL_ADMIN     => L_PROFIL_ADMIN,
                      PROFIL_MANAGER   => L_PROFIL_MANAGER,
                      PROFIL_MODERATOR => L_PROFIL_MODERATOR,
                      PROFIL_EDITOR    => L_PROFIL_EDITOR,
                      PROFIL_WRITER    => L_PROFIL_WRITER
                    );
$autoBL = array(      0 => $plxPlugin->getLang('L_SS_CONFIG_DO_NOT_AUTO_ADD_IP'),
                      PROFIL_ADMIN+1    => L_PROFIL_ADMIN,
                      PROFIL_MANAGER+1   => L_PROFIL_MANAGER,
                      PROFIL_MODERATOR+1 => L_PROFIL_MODERATOR,
                      PROFIL_EDITOR+1    => L_PROFIL_EDITOR,
                      PROFIL_WRITER+1    => L_PROFIL_WRITER
                    );
$ip = plxUtils::getIp();

?>
<link rel="stylesheet" href="<?php echo PLX_PLUGINS; ?>plxSimpleStat/css/config.css" type="text/css" media="screen" />
<script type="text/javascript" src="<?php echo PLX_PLUGINS; ?>plxSimpleStat/js/config.js"></script>
<div>
	<span class="tab_0 tab" id="tab_01" onclick="javascript:change_tab('01');"><?php $plxPlugin->lang('L_SS_TAB01') ?></span>
	<span class="tab_0 tab" id="tab_02" onclick="javascript:change_tab('02');"><?php $plxPlugin->lang('L_SS_TAB02') ?></span>
</div>
<div class="plxSimpleStat">
	<div class="content_tab" id="content_tab_01">
	<form action="parametres_plugin.php?p=plxSimpleStat" method="post">
		<fieldset>
		<div class="grid">
			<div class="col sml-12">		
			<label for="id_DroitAcces"><?php $plxPlugin->lang('L_SS_CONFIG_DROIT_ACCES') ?>&nbsp;:</label>
			<?php plxUtils::printSelect('DroitAcces', $aDroitAcces, $plxPlugin->DroitAcces) ?>
			<a class="hint"><span><?php $plxPlugin->lang('L_SS_HELP_DROIT_ACCES')?></span></a>
			</div>
		</div>
		<div class="grid">
			<div class="col sml-12">
			<label for="id_RegexRobot"><?php $plxPlugin->lang('L_SS_CONFIG_REGEX_ROBOT') ?>&nbsp;:</label>
			<?php plxUtils::printInput('RegexRobot', $plxPlugin->RegexRobot, 'text', '50-1000') ?>
			<a class="hint"><span><?php $plxPlugin->lang('L_SS_HELP_REGEX_ROBOT')?></span></a>
			</div>
		</div>
		<div class="grid">
			<div class="col sml-12">			
			<label for="BlacklistIP"><?php $plxPlugin->lang('L_SS_CONFIG_BLACKLIST_IP') ?></label>
			<textarea name="BlacklistIP" id="BlacklistIP"><?php echo $plxPlugin->getParam('BlacklistIP'); ?></textarea>
			<button type="button" onclick="addIP('<?php echo $ip ?>')" <?php if (empty($ip) || in_array($ip,$plxPlugin->BlacklistIP)) echo "disabled=disabled" ?>><?php $plxPlugin->lang('L_SS_CONFIG_BLACKLIST_IP_BUTTON') ?></button>
			<a class="hint"><span><?php $plxPlugin->lang('L_SS_HELP_BLACKLIST_IP')?></span></a>
			</div>
		</div>
		<div class="grid">
			<div class="col sml-12">		
			<label for="id_autoBlacklistLevel"><?php $plxPlugin->lang('L_SS_CONFIG_AUTO_BL_IP') ?></label>
			<?php plxUtils::printSelect('autoBlacklistLevel', $autoBL, $plxPlugin->autoBlacklistLevel) ?>
			</div>
		</div>
		<div class="grid">
			<div class="col sml-12">		
			<label for="SpamRef"><?php $plxPlugin->lang('L_SS_CONFIG_SPAMREF') ?></label>
			<textarea name="SpamRef" id="SpamRef"><?php echo $plxPlugin->getParam('SpamRef'); ?></textarea>
			<a class="hint"><span><?php $plxPlugin->lang('L_SS_HELP_SPAMREF')?></span></a>
			</div>
		</div>
		<div class="grid">
			<div class="col sml-12">
			<label for="id_RegexSpamRef"><?php $plxPlugin->lang('L_SS_CONFIG_REGEX_SPAMREF') ?>&nbsp;:</label>
			<?php plxUtils::printInput('RegexSpamRef', $plxPlugin->RegexSpamRef, 'text', '50-1000') ?>
			<a class="hint"><span><?php $plxPlugin->lang('L_SS_HELP_REGEX_SPAMREF')?></span></a>
			</div>
		</div>
		<div class="grid">
			<div class="col sml-12">	
				<label for="id_actAuto"><?php $plxPlugin->lang('L_SS_CONFIG_ACTAUTO') ?>&nbsp;:</label>
				<?php plxUtils::printSelect('ActAuto', array('1'=>L_YES,'0'=>L_NO), $plxPlugin->getParam('ActAuto')) ?>
			</div>
		</div>
		<div class="grid">
			<div class="col sml-12">	
				<label for="id_actAutoTime"><?php $plxPlugin->lang('L_SS_CONFIG_ACTAUTOTIME') ?>&nbsp;:</label>
				<?php plxUtils::printSelect('ActAutoTime', array('60'=>$plxPlugin->getlang('L_SS_CONFIG_1M'),'120'=>$plxPlugin->getlang('L_SS_CONFIG_2M'),'300'=>$plxPlugin->getlang('L_SS_CONFIG_5M')), $plxPlugin->getParam('ActAutoTime')) ?>
			</div>
		</div>
		</div>
			<p class="in-action-bar">
			<?php echo plxToken::getTokenPostMethod() ?>
			<input type="submit" name="submit" value="<?php $plxPlugin->lang('L_SS_SAVE') ?>" />
			<input type="submit" name="spamref" value="<?php $plxPlugin->lang('L_SS_UPDATE_SPAMREF') ?>" />
			</p>
		</fieldset>
	</form>
</div>
<div class="content_tab" id="content_tab_02">
	<div id="update">
		<?php $infoPlugin = $plxPlugin->simplestat->UpdatePlugin('plxSimpleStat'); ?>
		<p><?php $plxPlugin->lang('L_VP_ACTUAL_VERSION'); ?>&nbsp;:&nbsp;<?php echo $infoPlugin['actualversion'].' ('.$infoPlugin['actualdate'].')'; ?></p>	
		<?php if ($infoPlugin['status'] == 0) { ?>
			<p class="center"><span class="color"><?php $plxPlugin->lang('L_VP_ERROR'); ?></span></p>
			<p><a href="http://dpfpic.com" target="blank" title=""><img src="<?php echo PLX_PLUGINS; ?>plxSimpleStat/img/vers/up_warning.gif" alt=""></a></p>
		<?php } elseif ($infoPlugin['status'] == 1) { ?>
			<p><?php $plxPlugin->lang('L_VP_LAST_VERSION'); ?>&nbsp;<?php echo $infoPlugin['newplugin']; ?>.</p>
			<p><img src="<?php echo PLX_PLUGINS; ?>plxSimpleStat/img/vers/up_ok.gif" alt=""></p>
		<?php } elseif ($infoPlugin['status'] == 2) { ?>
			<p><?php $plxPlugin->lang('L_VP_NEW_VERSION'); ?><p>
			<p><span class="color"><?php echo $infoPlugin['newplugin']; ?>&nbsp;(<?php echo $infoPlugin['newversion']; ?>&nbsp;-&nbsp;<?php echo $infoPlugin['newdate']; ?>)</span></p>
			<p><?php $plxPlugin->lang('L_VP_NEW2_VERSION'); ?>.</p>
			<p><a href="<?php echo $infoPlugin['newurl']; ?>" target="blank" title=""><img src="<?php echo PLX_PLUGINS; ?>plxSimpleStat/img/vers/up_download.gif" alt=""></a></p>
		<?php } elseif ($infoPlugin['status'] == 3) {?>
		    <p class="center"><span class="color"><?php $plxPlugin->lang('L_VP_DESACTIVED'); ?></span></p>
			<p><a href="http://dpfpic.com" target="blank" title=""><img src="<?php echo PLX_PLUGINS; ?>plxSimpleStat/img/vers/up_warning.gif" alt=""></a></p>
		<?php } ?>	
	</div>
</div>	
<script type="text/javascript">
var anc_tab = '01';
change_tab(anc_tab);

function addIP(ip){
iplist = document.getElementById('BlacklistIP');
if (iplist.value.indexOf(ip)==-1) iplist.value+=ip+'\n';
return false;
}
</script>
